//
// io_demo.c 
// This contains various examples of interfacing to the GIO driver.
//

//#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

#include "gio_driver.h"
#include <Winbase.h>


BYTE ReadValue(HANDLE gio,BYTE byPort);
WORD ReadWordValue(HANDLE gio,BYTE byPort);
void WriteValue(HANDLE gio, BYTE byPort, BYTE byValue);
void ioScript(HANDLE gio, struct stRec *s, BYTE invert, DWORD dlyMultiplier);
void showBin (DWORD bin, char bits);
void digitalIOtest(void);

// Struct used by iotest. 
struct stRec {
				BYTE  port;  // a port supported by the GIO driver
				BYTE  data;  // data to write to the port
				BYTE  delay; // delay multiplier. This is multiplied 
			};








void digitalIOtest(void)
{
	HANDLE hGIO;
	BYTE bval;
	WORD wval;
	int x;

	const struct stRec ioTestScriptCfg1[] = {
	   {PORT_A_CFG	     ,0xff , 0},
	   {PORT_B_CFG	     ,0xff , 0},
	   {PORT_C_CFG	     ,0xff , 0},
	   {PORT_IOBLK1_CFG	 ,0xff , 0},
	   {PORT_IOBLK2_CFG	 ,0xff , 0},
	   {0				 ,0    , 255} 
	};

	const struct stRec ioTestScriptCfgInputs[] = {
	   {PORT_A_CFG		,0 , 0},
	   {PORT_B_CFG		,0 , 0},
	   {PORT_C_CFG		,0 , 0},
	   {PORT_IOBLK1_CFG	,0 , 0},
	   {PORT_IOBLK2_CFG	,0 , 0},
	   {0				,0 , 255} 
	};

	const struct stRec ioTestScriptPLD[] = {
	   {PORT_A_DAT	  		,0 , 0},
	   {PORT_B_DAT	  		,0 , 0},
	   {PORT_C_DAT	  		,255 , 0},
	   {PORT_A_DAT	  		,1, 1},
	   {PORT_A_DAT	  		,2, 1},
	   {PORT_A_DAT	  		,4, 1},	
	   {PORT_A_DAT	  		,8, 1},
	   {PORT_A_DAT	  		,16, 1},
	   {PORT_A_DAT	  		,32, 1},
	   {PORT_A_DAT	  		,64, 1},	
	   {PORT_A_DAT	  		,128, 1},
	   {PORT_A_DAT	  		,0 , 0},
	   {PORT_B_DAT	  		,1 , 1},
	   {PORT_B_DAT	  		,2 , 1},
	   {PORT_B_DAT	  		,4 , 1},	
	   {PORT_B_DAT	  		,8 , 1},
	   {PORT_B_DAT	  		,16 , 1},
	   {PORT_B_DAT	  		,32 , 1},
	   {PORT_B_DAT	  		,64 , 1},	
	   {PORT_B_DAT	  		,128 , 1},
	   {PORT_B_DAT	  		,0 , 0},
	   {PORT_C_DAT	  		,255-1 , 1},
	   {PORT_C_DAT	  		,255-2 , 1},
	   {PORT_C_DAT	  		,255-4 , 1},	
	   {PORT_C_DAT	  		,255-8 , 1},
	   {PORT_C_DAT	  		,255-16 , 1},
	   {PORT_C_DAT	  		,255-32 , 1},
	   {PORT_C_DAT	  		,255-64 , 1},	
	   {PORT_C_DAT	  		,255-128 , 1},
	   {PORT_C_DAT	  		,255-0 , 0},
	   {0             		,0 , 255}
	};

	const struct stRec ioTestScriptCirrusIO[] = {
	   {PORT_IOBLK2_DAT		,0 , 0},
	   {PORT_IOBLK1_DAT		,0 , 0},
	   {PORT_IOBLK1_DAT		,1 , 1},
	   {PORT_IOBLK1_DAT		,2 , 1},
	   {PORT_IOBLK1_DAT		,4 , 1},	
	   {PORT_IOBLK1_DAT		,8 , 1},
	   {PORT_IOBLK1_DAT		,16 , 1},
	   {PORT_IOBLK1_DAT		,32 , 1},
	   {PORT_IOBLK1_DAT		,64 , 1},	
	   {PORT_IOBLK1_DAT		,128 , 1},
	   {PORT_IOBLK1_DAT		,0 , 0},
	   {PORT_IOBLK2_DAT		,1 , 1},
	   {PORT_IOBLK2_DAT		,2 , 1},
	   {PORT_IOBLK2_DAT		,0 , 0},
	   {0             		,0 , 255}
	};
	//const struct stRec ioTestScript1[] = {
	//   {PORT_IOBLK1_DAT		,0 , 0},
	//   {PORT_IOBLK1_DAT		,128 , 1},
	//   {PORT_IOBLK1_DAT		,0 , 0},
	//   {PORT_IOBLK2_DAT		,1 , 1},
	//   {PORT_IOBLK2_DAT		,2 , 1},
	//   {PORT_IOBLK2_DAT		,4 , 1},	
	//   {PORT_IOBLK2_DAT		,0 , 0},
	//   {0             		,0 , 255}
	//};

	const struct stRec ioTestScript2[] = {
	   {PORT_A_DAT	  		,0 , 0},
	   {PORT_B_DAT	  		,0 , 0},
	   {PORT_C_DAT	  		,0 , 0},
	   {PORT_IOBLK1_DAT	  	,0 , 0},
	   {PORT_IOBLK2_DAT	  	,0 , 0},
	   {PORT_A_DAT	  		,0xaa, 0},
	   {PORT_B_DAT	  		,0xaa, 0},
	   {PORT_C_DAT	  		,0xaa, 2},	
	   {PORT_A_DAT	  		,0x55, 0},
	   {PORT_B_DAT	  		,0x55, 0},
	   {PORT_C_DAT	  		,0x55, 2},	
	   {PORT_A_DAT	  		,0xaa, 0},
	   {PORT_B_DAT	  		,0xaa, 0},
	   {PORT_C_DAT	  		,0xaa, 2},	
	   {PORT_A_DAT	  		,0x55, 0},
	   {PORT_B_DAT	  		,0x55, 0},
	   {PORT_C_DAT	  		,0x55, 2},	
	   {0             		,0 , 255}
	};

	const struct stRec ioScriptTestingCFGportsCFGinit[] = {
   	   {PORT_A_CFG		,0xaa , 0},
	   {PORT_B_CFG		,0xaa , 0},
	   {PORT_C_CFG		,0xaa , 0},
	   {PORT_IOBLK1_CFG	,0xaa , 0},
	   {PORT_IOBLK2_CFG	,0xaa , 0},
	   {0				,0 , 255} 
	};

	//
	// The following script sets all outputs to 0 (except port C since it is inverted) so that when
	// the port is an output it lights an LED.
	//
	const struct stRec ioScriptTestingCFGportsDATinit[] = {
	   {PORT_A_DAT		,0 , 0},
	   {PORT_B_DAT		,0 , 0},
	   {PORT_C_DAT		,0XFF , 0},
	   {PORT_IOBLK1_DAT	,0 , 0},
	   {PORT_IOBLK2_DAT	,0 , 0},
	   {0				,0 , 255} 
	};


    // Open the GIO device.
	hGIO = CreateFile(L"GIO1:",	                 // the device to open
				GENERIC_READ | GENERIC_WRITE,	 // Open for read/write
				0,								 // Share for reading
				NULL,							 // No security
				OPEN_EXISTING,					 // Existing file only
				0,								 // Normal file
				NULL);							 // No template file

	if (hGIO == INVALID_HANDLE_VALUE)
	{
		_tprintf(_T("Unable to open GIO driver %x\n"),(DWORD)hGIO);
		return;
	}

	bval = 	ReadValue(hGIO, PORT_PLD_ID);
	_tprintf(_T(" SOM-200ES PLD ID = %0X\r\n"),bval);

	bval = 	ReadValue(hGIO, PORT_DRIVER_ID);
	_tprintf(_T(" Driver targeted to PLD ID %0X\r\n"),bval);
	if (bval != ReadValue(hGIO, PORT_PLD_ID))
	{
		_tprintf(_T(" PLD and driver mismatch. \r\n"),bval);
		return; 
	}

#if 1
	//
	// The following script alternates setting every other pin as an output
	//
	_tprintf(_T("Inputs test. \r\n"));
	ioScript(hGIO, ioScriptTestingCFGportsCFGinit, 0 , 300);
	ioScript(hGIO, ioScriptTestingCFGportsDATinit, 0 , 300);

	//for (x=1; x< 8; x++)
	while (1)
	{
		ioScript(hGIO, ioScriptTestingCFGportsCFGinit, 0 , 0);
		Sleep(300); 
		ioScript(hGIO, ioScriptTestingCFGportsCFGinit, 1 , 0);
		Sleep(300); 
	}
#endif

	//_tprintf(_T("Set all the IOs as outputs. \r\n"));
	//ioScript(hGIO, ioTestScriptCfg1, 0 , 300);

	//
	// Looping IOBLK1 to IOBLK2.
	//
	//while(1)
	//{
	//	bval = ReadValue(hGIO, PORT_IOBLK1_DAT);
	//	if (!bval&0x40) 
	//		return;
	//	showBin ((DWORD) bval, 4);
	//	_tprintf(_T("\r\n"));
	//	WriteValue(hGIO,PORT_IOBLK2_DAT, bval);
	//}



	//while (1)
	//{
	//	ioScript(hGIO, ioTestScript2, 0 , 300);	
	//};
	
#if 0
	_tprintf(_T("Set all the PLD IOs as outputs. \r\n"));
	ioScript(hGIO, ioTestScriptCfg1, 0 , 300);

	do 
	{
		// Set all the IOs low then walk a 1 bit through each IO line.
		_tprintf(_T("Walking a 1 bit.... \r\n"));
		ioScript(hGIO, ioTestScriptPLD, 0 , 300);
		Sleep(1000); 

		// Set all the IOs high then walk a 0 bit through each IO line.
		_tprintf(_T("Walking a 0 bit.... \r\n"));
		ioScript(hGIO, ioTestScriptPLD, 1 , 300);
		Sleep(1000); 
	}
	while(1);


	//_tprintf(_T("Set all the IOs as inputs. \r\n"));
	//ioScript(hGIO, ioTestScriptCfgInputs, 0 , 300);

		_tprintf(_T("Set all the IOs as outputs. \r\n"));
	ioScript(hGIO, ioTestScriptCfg1, 0 , 300);


		_tprintf(_T("   76543210   76543210      76543210      210 \r\n"));
	do
	{	
		_tprintf(_T(" A-"));
		showBin((DWORD)ReadValue(hGIO, PORT_A_DAT     ),8);
									   
		_tprintf(_T(" B-"));		   
		showBin((DWORD)ReadValue(hGIO, PORT_B_DAT	  ),8);
									   
		_tprintf(_T(" BLK1-"));		   
		showBin((DWORD)ReadValue(hGIO, PORT_IOBLK1_DAT),8);

		_tprintf(_T(" BLK2-"));		   
		showBin((DWORD)ReadValue(hGIO, PORT_IOBLK2_DAT),3);

									   
		_tprintf(_T("\r"));			   
		Sleep(200);					  
	}
	while (1);

#endif

	_tprintf(_T("\r\n adc readings "));

	while(1)
	{
		wval = ReadWordValue(hGIO, PORT_SXP);
		_tprintf(_T("SXP=%5d"),(ULONG)wval);

		wval = ReadWordValue(hGIO, PORT_SXM);
		_tprintf(_T("  SXM=%5d"),(ULONG)wval);

		wval = ReadWordValue(hGIO, PORT_SYM);
		_tprintf(_T("  SYM=%5d"),(ULONG)wval);

		wval = ReadWordValue(hGIO, PORT_SYP);
		_tprintf(_T("  SYP=%5d"),(ULONG)wval);

		wval = ReadWordValue(hGIO, PORT_ANLMIN);
		_tprintf(_T("   MIN = %5d"),(ULONG)wval);

		wval = ReadWordValue(hGIO, PORT_ANLMAX);
		_tprintf(_T("  MAX = %5d\r\n"),(ULONG)wval);

	};

	_tprintf(_T(" Finished....Closing GIO. \r\n"));	
	CloseHandle(hGIO);
}


//
// Reads a value from a port.
//

BYTE ReadValue(HANDLE gio,BYTE byPort)
{
	BYTE	byRetValue = 0x00;
	BYTE	byDataPort = byPort;	 
	DWORD	nBytesReturned = 0;

	DeviceIoControl(gio, IOCTL_GIO_READ_BYTE, &byDataPort, (DWORD)sizeof(byDataPort),
		&byRetValue, (DWORD)sizeof(byRetValue), &nBytesReturned, NULL);

	return byRetValue;
}

//
// Reads a value from a 16 bit (WORD) port.
//

WORD ReadWordValue(HANDLE gio,BYTE byPort)
{
	WORD	byRetValue = 0x00;
	BYTE	byDataPort = byPort;	 
	DWORD	nBytesReturned = 0;

	DeviceIoControl(gio, IOCTL_GIO_READ_BYTE, &byDataPort, (DWORD)sizeof(byDataPort),
		&byRetValue, (DWORD)sizeof(byRetValue), &nBytesReturned, NULL);

	return byRetValue;
}


// 
// Writes a value to a port.
//
void WriteValue(HANDLE gio, BYTE byPort, BYTE byValue)
{
	GIO_WRITE_VALUE wv;
	wv.byPortNumber = byPort;
	wv.byValue = byValue;

	DeviceIoControl(gio, IOCTL_GIO_WRITE_BYTE, &wv, (DWORD)sizeof(wv), NULL, 0, NULL, NULL);
}


//
// This allows running a "script" for configuring and controlling IO ports.
// The end of the script is indicated by s->delay == 255.
// Takes as input a handle to the GIO driver, a pointer to an array of structure "stRec"
// an "invert" parameter (which causes the function write the complement of the data to the port)
// and a delay multiplier (in milliseconds)which is multiplied by the delay in each script element 
// to provide a delay after each element in the script is parsed.
//
void ioScript(HANDLE gio, struct stRec *s, BYTE invert, DWORD dlyMultiplier)
{
	BYTE tmp;

	while (s->delay < 255)
	{
		if (invert)
			tmp = ~s->data;
		else
			tmp = s->data;

		WriteValue(gio,s->port, tmp);
		if (s->delay)
			Sleep((DWORD)((WORD)s->delay * dlyMultiplier)); 
		s++;
	}
}



//
// Show in binary <bits> bits of the number <bin>
//
void showBin (DWORD bin, char bits)
{
 char i;
 
 bin<<=(32-bits); // get rid of the unused bits first
 for (i=0;i<bits; i++)
  {
   if (bin&0x80000000)
      _tprintf(_T("1"));
   else
      _tprintf(_T("0"));
      
   bin<<=1;   
  } 
}
             
void com3Demo(void)
{
	DCB comSettings;
	DWORD dwWritten;
	HANDLE hCOM3;
	char t[]= {"this is a test of COM   "};

	_tprintf(_T("Open COM3 \r\n"));

	hCOM3 = CreateFile(L"COM3:",	                 // the device to open
				GENERIC_READ | GENERIC_WRITE,	 // Open for read/write
				0,								 // Share for reading
				NULL,							 // No security
				OPEN_EXISTING,					 // Existing file only
				0,								 // Normal file
				NULL);							 // No template file

	if (hCOM3 == INVALID_HANDLE_VALUE)
	{
	    _tprintf(_T("Unable to open COM3 %x\n"),(DWORD)hCOM3);
		return;
	}

	comSettings.DCBlength = sizeof(DCB);
	GetCommState(hCOM3, &comSettings);
	comSettings.BaudRate = CBR_38400;
	comSettings.StopBits  = ONESTOPBIT;
	comSettings.Parity    = NOPARITY;
	comSettings.fOutxCtsFlow  = 0;
	comSettings.fOutxDsrFlow  = 0;
	comSettings.fDtrControl  = DTR_CONTROL_DISABLE;
	comSettings.fRtsControl  = RTS_CONTROL_DISABLE;

	if(!SetCommState(hCOM3, &comSettings)) 
	{
		CloseHandle(hCOM3);
		_tprintf(_T(" unable to set baud \r\n"));
		return;
    }
	else
		// send to COM3
	   if (!WriteFile(hCOM3, t, sizeof(t), &dwWritten, 0)) 
	   {
		  _tprintf(_T(" writefile error COM3.   written=%x \r\n"),(DWORD)dwWritten);
	   }

	Sleep(200);
	_tprintf(_T("Close COM3 \r\n"));
	CloseHandle(hCOM3);
}


